
/*
 * Flock.java
 *
 * Created on May 17, 2007, 12:36 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import info.gridworld.actor.Actor;
import java.util.*;

/**
 *
 * @author cday
 */
public class Flock {
    List <Flockable> theFlock = new ArrayList<Flockable>();
    Actor theLeader;

    /**
     *  Add f to the group of Flockables objects in this Flock
     *  @param  f   A Flockable object to be added to this Flock
     **/
    public void add(Flockable f) {
        theFlock.add(f);
    }

    /**
     *  Return an Iterator over the group of Flockable objects in this Flock
     **/
    public Iterator <Flockable> iterator() {
        return theFlock.iterator();
    }   

    /**
     *  Define the leader of this Flock.  Without a leader, each Flockable
     *  in this Flock will act of its own accord.  Given a leader, each 
     *  Flockable object should follow that leader
     *  @param  leader  The Actor to follow
     **/
    public void addLeader(Actor leader) {
        theLeader = leader;
        Iterator <Flockable> flockIter = iterator();
        while (flockIter.hasNext()) {
            Flockable nextFlockObject = flockIter.next();
            nextFlockObject.setLeader(leader);
        }
    }
    
    /**
     *  Remove the leader from this Flock.  All Flockable objects in this Flock
     *  should now act of their own accord
     **/
    public void removeLeader() {
        theLeader = null;
        Iterator <Flockable> flockIter = iterator();
        while (flockIter.hasNext()) {
            flockIter.next().stopFollowing();
        }
    }
}
