
/*
 * Flockable.java
 *
 * Created on May 16, 2007, 3:00 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import info.gridworld.actor.Actor;

/**
 *
 * @author cday
 */
public interface Flockable {
    /**
     *  Provide this Flockable object with a leader that it can follow.
     *  Subsequent actions by this Flockable object should cause it to behave
     *  in a manner that causes it to follow flockLeader
     *  @param  flockLeader The Actor that this Flockable will follow
     **/
    public void setLeader(Actor flockLeader);
    
    /**
     *  Instruct this Flockable object to permanently  stop following its leader
     **/
    public void stopFollowing();

    /**
     *  Return true if this Flockable has a leader that it is following
     *  @return true if this Flockable has a leader, false otherwise
     **/
    public boolean isFollowing();    
}
